<?xml version="1.0" encoding="ISO-8859-1"?>
<!--
   Copyright (C) 2002-2003 Index Data Aps, www.indexdata.dk

   This file is part of TKL.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; version 2 dated June, 1991.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   A copy of the GNU General Public License is also available at
   <URL:http://www.gnu.org/copyleft/gpl.html>.  You may also obtain
   it by writing to the Free Software Foundation, Inc., 59 Temple
   Place - Suite 330, Boston, MA 02111-1307, USA.

   $Id: rss-news.xsl,v 1.1 2004/03/17 14:51:02 anders Exp $
-->
<xsl:stylesheet
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:portcom="http://www.indexdata.dk/TKL"
    xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
    xmlns:rss="http://purl.org/rss/1.0/"
    version="1.0">

    <xsl:import href="tkl-file://interface.xsl"/>
    <xsl:include href="tkl-file://rss/rss-feed.xsl"/>
    <xsl:include href="tkl-file://news.xsl"/>

    <xsl:output method="html" encoding="UTF-8"/>

<xsl:template match="/rss-news">
    <xsl:call-template name="main-page">
        <xsl:with-param name="title" select="title"/>
    </xsl:call-template>
</xsl:template>


<xsl:template name="main-news-content">
    <xsl:call-template name="read-news"/>
</xsl:template>

<xsl:template name="main-body">
    <xsl:call-template name="insert-path"/>

    <!-- Get the rss feeds -->
    
    <xsl:variable name="feeds">
      <xsl:for-each select="document(
                     'tkl-find://?path=rss-feed*.tkl&amp;select=title|identifier|ttl|encoding|file')/*/file">
        <xsl:copy-of select="."/>
      </xsl:for-each>
    </xsl:variable>

    <xsl:for-each select="$feeds/file">
      <xsl:variable name="rssdata" select="document(
        concat('tkl-rss://?url=',./identifier,'&amp;file=',./file,'&amp;ttl=',./ttl,'&amp;encoding=',./encoding)
        )"/>
       <xsl:call-template name="rss_channel">
          <xsl:with-param name="test" select="$rssdata"/>
       </xsl:call-template> 

       <br />
    </xsl:for-each>

</xsl:template>

</xsl:stylesheet>

