/* $Id: save_handler.php,v 1.1 2004/10/14 10:20:21 sondberg Exp $
 * ---------------------------------------------------------------------
 * Save schema handler: Automatically place a stored file in a hierachy
 * of directories.
 *
 * You'll need to add this XML schema annotation (right below the schema
 * document element (xs:schema):
 *
 * <xs:annotation>
 *   <xs:documentation>
 *     <schemaInfo>Here goes some </schemaInfo>
 *   </xs:documentation>
 *   <xs:appinfo>
 *     <handler targetDir="/xxx" depth="nn">save_handler.php</handler>
 *   </xs:appinfo>
 * </xs:annotation>
 *
 * where /xxx is the target root directory relative to the Keystone portal
 * root, and where depth is the (integer) number of levels in the
 * directory hierarchy. Example: For depth=2, files will be distributed in
 * directories of the form /xxx/y/z/file.tkl
 *
 */
                 

require_once( 'search.php' );

if ($args['action'] == 'commit') {
    $depth = $args['attr']['depth'];
    $target = $args['attr']['targetDir'];
    $md5 = md5( $args['tkl_doc'] );
    $level = 0;
    $basedir = $_SERVER['DOCUMENT_ROOT'] . "/" . $args['portal_root'];
    $targetdir = $basedir . "/" . $target;

    if ( !isset( $depth )  || !strlen( $depth ) ||
         !isset( $target ) || !strlen( $target ) ) {

        die( basename( __FILE__ ) . ": Attributes targetDir and depth must be specified in schema" );
    }

    while ( $level < $depth && preg_match( "/^(\w)/", $md5, $match ) ) {
        $md5 = preg_replace( "/^\w/", "", $md5 );
        $level ++;
        $targetdir .= "/" . $match[1];

        if ( !is_dir( $targetdir ) ) {
            if ( !mkdir( $targetdir, 0755 ) ) {
                die( basename( __FILE__ ) . ": Unable to create directory '$targetdir'" );
            }
        }
    }

    $src = $basedir . "/" . $args['portal_abs_dir'] . "/" . $args['tkl_doc'];
    $dest = $targetdir . "/" . $args['tkl_doc'];
    
    if ( !rename( $src, $dest ) ) {
        die( basename( __FILE__ ) . ": Unable to move $src into $dest" );
    }

    // Update Zebra index with the new location of the file:
    search_index( $dest );

    // Delete the old file from the index:
    $old_dir = $basedir . "/" . $args['portal_abs_dir'];
    search_index( $old_dir );
    
} else {
    die("<b>Fatal:</b> Unknown type of action '" . $args['action'] . "'");
}
