<?xml version="1.0"?>
<!-- $Id: header_preprint.xsl,v 1.1 2004/01/22 13:09:43 franck Exp $ -->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:strip-space elements="*"/>
<xsl:output method="html" indent="no" encoding="utf-8"/>

<xsl:template match="/">
    <xsl:apply-templates select="/record"/>
</xsl:template>

<xsl:template match="/record"
    xmlns:dc="http://purl.org/dc/elements/1.1/"
    xmlns:oai_dc="http://www.openarchives.org/OAI/2.0/oai_dc/">
    <xsl:variable name="title">
        <xsl:value-of select="normalize-space (metadata/oai_dc:dc/dc:title)"/>
    </xsl:variable>
    <font class="list_title">
        <xsl:element name="zebril">
            <xsl:attribute name="action">show</xsl:attribute>
            <xsl:choose>
                <xsl:when test="string-length ($title) > 70">
                    <xsl:value-of select="substring ($title, 1, 67)"/>
                    <xsl:text>...</xsl:text>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:value-of select="$title"/>
                </xsl:otherwise>
            </xsl:choose>
        </xsl:element>
    </font>
    /
    <font class="list_author">
        <xsl:choose>
            <xsl:when test="metadata/oai_dc:dc/dc:creator">
                 <xsl:value-of select="normalize-space (metadata/oai_dc:dc/dc:creator)"/>
            </xsl:when>
            <xsl:otherwise>
                 <xsl:value-of select="normalize-space (metadata/oai_dc:dc/dc:contributor)"/>
            </xsl:otherwise>
        </xsl:choose>
    </font>
    <font class="list_text">
        <xsl:text> (</xsl:text>
    </font>
    <font class="list_server">
        <xsl:value-of select="normalize-space (server/searchName)"/>
    </font>
    <font class="list_text">
        <xsl:text>) </xsl:text>
    </font>
</xsl:template>

</xsl:stylesheet>
